;/*
;** $Id: lua.h,v 1.216 2006/01/10 12:50:13 roberto Exp $
;** Lua - An Extensible Extension Language
;** Lua.org, PUC-Rio, Brazil (http://www.lua.org)
;** See Copyright Notice at the end of this file
;*/
;
;
;
;#ifndef lua_h
;#define lua_h
;
;#include <stdarg.h>
;#include <stddef.h>
;
;
;#include "luaconf.h"
;
;
;#define LUA_VERSION	"Lua 5.1"
;#define LUA_VERSION_NUM	501
;#define LUA_COPYRIGHT	"Copyright (C) 1994-2006 Lua.org, PUC-Rio"
;#define LUA_AUTHORS 	"R. Ierusalimschy, L. H. de Figueiredo & W. Celes"
;
;
;/* mark for precompiled code (`<esc>Lua') */
;#define	LUA_SIGNATURE	"\033Lua"
;
;/* option for multiple returns in `lua_pcall' and `lua_call' */
LUA_MULTRET	equ	(-1)

LUA_IDSIZE	equ	60

;/*
;** pseudo-indices
;*/
LUA_REGISTRYINDEX	equ	(-10000)
LUA_ENVIRONINDEX	equ	(-10001)
LUA_GLOBALSINDEX	equ	(-10002)
;lua_upvalueindex(i)	(LUA_GLOBALSINDEX-(i))


;/* thread status; 0 is OK */
LUA_YIELD			equ	1
LUA_ERRRUN		equ	2
LUA_ERRSYNTAX	equ	3
LUA_ERRMEM		equ	4
LUA_ERRERR		equ	5

;typedef struct lua_State lua_State;
;
;typedef int (*lua_CFunction) (lua_State *L);
;
;
;/*
;** functions that read/write blocks when loading/dumping Lua chunks
;*/
;typedef const char * (*lua_Reader) (lua_State *L, void *ud, size_t *sz);
;
;typedef int (*lua_Writer) (lua_State *L, const void* p, size_t sz, void* ud);
;
;
;/*
;** prototype for memory-allocation functions
;*/
;typedef void * (*lua_Alloc) (void *ud, void *ptr, size_t osize, size_t nsize);
;
;
;/*
;** basic types
;*/
LUA_TNONE		equ (-1)

LUA_TNIL						equ	0
LUA_TBOOLEAN				equ	1
LUA_TLIGHTUSERDATA	equ	2
LUA_TNUMBER					equ	3
LUA_TSTRING					equ	4
LUA_TTABLE					equ	5
LUA_TFUNCTION				equ	6
LUA_TUSERDATA				equ	7
LUA_TTHREAD					equ	8

;/* minimum Lua stack available to a C function */
LUA_MINSTACK				equ	20

;/*
;** generic extra include file
;*/
;#if defined(LUA_USER_H)
;#include LUA_USER_H
;#endif


;/* type of numbers in Lua */
;typedef LUA_NUMBER lua_Number;


;/* type for integer functions */
;typedef LUA_INTEGER lua_Integer;



;/*
;** state manipulation
;*/

lua_newstate	PROTO C :DWORD, :DWORD
lua_close			PROTO C :DWORD
lua_newthread	PROTO C :DWORD

lua_atpanic		PROTO C :DWORD, :DWORD

;/*
;** basic stack manipulation
;*/
lua_gettop		PROTO C :DWORD
lua_settop		PROTO C :DWORD, :DWORD
lua_pushvalue	PROTO C :DWORD, :DWORD
lua_remove		PROTO C :DWORD, :DWORD
lua_insert		PROTO C :DWORD, :DWORD
lua_replace		PROTO C :DWORD, :DWORD
lua_checkstack	PROTO C :DWORD, :DWORD

lua_xmove	PROTO C :DWORD, :DWORD, :DWORD

;/*
;** access functions (stack -> C)
;*/

lua_isnumber		PROTO C :DWORD, :DWORD
lua_isstring		PROTO C :DWORD, :DWORD
lua_iscfunction	PROTO C :DWORD, :DWORD
lua_isuserdata	PROTO C :DWORD, :DWORD
lua_type				PROTO C :DWORD, :DWORD
lua_typename		PROTO C :DWORD, :DWORD

lua_equal			PROTO C :DWORD, :DWORD, :DWORD
lua_rawequal	PROTO C :DWORD, :DWORD, :DWORD
lua_lessthan	PROTO C :DWORD, :DWORD, :DWORD

lua_tonumber	PROTO C :DWORD, :DWORD
lua_tointeger	PROTO C :DWORD, :DWORD
lua_toboolean	PROTO C :DWORD, :DWORD
lua_tolstring	PROTO C :DWORD, :DWORD, :DWORD ; last parameter to NULL if you want a C string
lua_objlen		PROTO C :DWORD, :DWORD
lua_tocfunction	PROTO C :DWORD, :DWORD
lua_touserdata	PROTO C :DWORD, :DWORD
lua_tothread		PROTO C :DWORD, :DWORD
lua_topointer		PROTO C :DWORD, :DWORD


;/*
;** push functions (C -> stack)
;*/
lua_pushnil			PROTO C :DWORD
lua_pushnumber	PROTO C :DWORD, :REAL8	; Assuming lua_Number is a double
lua_pushinteger	PROTO C :DWORD, :DWORD	;	Assuming lua_Integer is a dword
lua_pushlstring	PROTO C :DWORD, :DWORD, :DWORD
lua_pushstring	PROTO C :DWORD, :DWORD
lua_pushvfstring	PROTO C :DWORD, :DWORD, :DWORD
lua_pushfstring		PROTO C :DWORD, :DWORD, :VARARG
lua_pushcclosure	PROTO C :DWORD, :DWORD, :DWORD	; last parameter to 0 if you want lua_pushcfunction
lua_pushboolean		PROTO C :DWORD, :DWORD
lua_pushlightuserdata	PROTO C :DWORD, :DWORD
lua_pushthread		PROTO C :DWORD


;/*
;** get functions (Lua -> stack)
;*/
lua_gettable			PROTO C :DWORD, :DWORD
lua_getfield			PROTO C :DWORD, :DWORD, :DWORD
lua_rawget				PROTO C :DWORD, :DWORD
lua_rawgeti				PROTO C :DWORD, :DWORD, :DWORD
lua_createtable		PROTO C :DWORD, :DWORD, :DWORD
lua_newuserdata		PROTO C :DWORD, :DWORD
lua_getmetatable	PROTO C :DWORD, :DWORD
lua_getfenv				PROTO C :DWORD, :DWORD


;/*
;** set functions (stack -> Lua)
;*/
lua_settable			PROTO C :DWORD, :DWORD
lua_setfield			PROTO C :DWORD, :DWORD, :DWORD
lua_rawset				PROTO C :DWORD, :DWORD
lua_rawseti				PROTO C :DWORD, :DWORD, :DWORD
lua_setmetatable	PROTO C :DWORD, :DWORD
lua_setfenv				PROTO C :DWORD, :DWORD


;/*
;** `load' and `call' functions (load and run Lua code)
;*/
lua_call		PROTO C :DWORD, :DWORD, :DWORD
lua_pcall		PROTO C :DWORD, :DWORD, :DWORD, :DWORD
lua_cpcall	PROTO C :DWORD, :DWORD, :DWORD
lua_load		PROTO C :DWORD, :DWORD, :DWORD, :DWORD
lua_dump		PROTO C :DWORD, :DWORD, :DWORD


;/*
;** coroutine functions
;*/
lua_yield		PROTO C :DWORD, :DWORD
lua_resume	PROTO C :DWORD, :DWORD
lua_status	PROTO C :DWORD

;/*
;** garbage-collection function and options
;*/
LUA_GCSTOP				equ	0
LUA_GCRESTART			equ	1
LUA_GCCOLLECT			equ	2
LUA_GCCOUNT				equ	3
LUA_GCCOUNTB			equ	4
LUA_GCSTEP				equ	5
LUA_GCSETPAUSE		equ	6
LUA_GCSETSTEPMUL	equ	7

lua_gc	PROTO C :DWORD, :DWORD, :DWORD

;/*
;** miscellaneous functions
;*/
lua_error		PROTO C :DWORD
lua_next		PROTO C :DWORD, :DWORD
lua_concat	PROTO C :DWORD, :DWORD

lua_getallocf	PROTO C :DWORD, :DWORD
lua_setallocf	PROTO C :DWORD, :DWORD, :DWORD

;/* 
;** ===============================================================
;** some useful macros
;** ===============================================================
;*/

;#define lua_pop(L,n)		lua_settop(L, -(n)-1)
;
;#define lua_newtable(L)		lua_createtable(L, 0, 0)
;
;#define lua_register(L,n,f) (lua_pushcfunction(L, (f)), lua_setglobal(L, (n)))
;
;#define lua_pushcfunction(L,f)	lua_pushcclosure(L, (f), 0)
;
;#define lua_strlen(L,i)		lua_objlen(L, (i))
;
;#define lua_isfunction(L,n)	(lua_type(L, (n)) == LUA_TFUNCTION)
;#define lua_istable(L,n)	(lua_type(L, (n)) == LUA_TTABLE)
;#define lua_islightuserdata(L,n)	(lua_type(L, (n)) == LUA_TLIGHTUSERDATA)
;#define lua_isnil(L,n)		(lua_type(L, (n)) == LUA_TNIL)
;#define lua_isboolean(L,n)	(lua_type(L, (n)) == LUA_TBOOLEAN)
;#define lua_isthread(L,n)	(lua_type(L, (n)) == LUA_TTHREAD)
;#define lua_isnone(L,n)		(lua_type(L, (n)) == LUA_TNONE)
;#define lua_isnoneornil(L, n)	(lua_type(L, (n)) <= 0)
;
;#define lua_pushliteral(L, s)	\
;	lua_pushlstring(L, "" s, (sizeof(s)/sizeof(char))-1)
;
;#define lua_setglobal(L,s)	lua_setfield(L, LUA_GLOBALSINDEX, (s))
;#define lua_getglobal(L,s)	lua_getfield(L, LUA_GLOBALSINDEX, (s))
;
;#define lua_tostring(L,i)	lua_tolstring(L, (i), NULL)
;
;

;/*
;** compatibility macros and functions
;*/
;
;#define lua_open()	luaL_newstate()
;
;#define lua_getregistry(L)	lua_pushvalue(L, LUA_REGISTRYINDEX)
;
;#define lua_getgccount(L)	lua_gc(L, LUA_GCCOUNT, 0)
;
;#define lua_Chunkreader		lua_Reader
;#define lua_Chunkwriter		lua_Writer



;/*
;** {======================================================================
;** Debug API
;** =======================================================================
;*/


;/*
;** Event codes
;*/
LUA_HOOKCALL		equ	0
LUA_HOOKRET			equ	1
LUA_HOOKLINE		equ	2
LUA_HOOKCOUNT		equ	3
LUA_HOOKTAILRET equ	4


;/*
;** Event masks
;*/
LUA_MASKCALL	equ	1
LUA_MASKRET		equ	2
LUA_MASKLINE	equ	4
LUA_MASKCOUNT	equ	8

;typedef struct lua_Debug lua_Debug;  /* activation record */


;/* Functions to be called by the debuger in specific events */
;typedef void (*lua_Hook) (lua_State *L, lua_Debug *ar);


lua_getstack	PROTO C :DWORD, :DWORD, :DWORD
lua_getinfo		PROTO C :DWORD, :DWORD, :DWORD
lua_getlocal	PROTO C :DWORD, :DWORD, :DWORD
lua_setlocal	PROTO C :DWORD, :DWORD, :DWORD
lua_getupvalue	PROTO C :DWORD, :DWORD, :DWORD
lua_setupvalue	PROTO C :DWORD, :DWORD, :DWORD

lua_sethook				PROTO C :DWORD, :DWORD, :DWORD, :DWORD
lua_gethook				PROTO C :DWORD
lua_gethookmask		PROTO C :DWORD
lua_gethookcount	PROTO C :DWORD

lua_Debug struct
  event				dword	?
  _name				dword	?
  namewhat		dword	?
  what				dword	?
  source			dword	?
  currentline	dword	?
  nups				dword	?
  linedefined	dword	?
  lastlinedefined	dword	?
  short_src		byte LUA_IDSIZE dup(?)
  
  i_ci				dword	?
lua_Debug ends

;/* }====================================================================== */

;/******************************************************************************
;* Copyright (C) 1994-2006 Lua.org, PUC-Rio.  All rights reserved.
;*
;* Permission is hereby granted, free of charge, to any person obtaining
;* a copy of this software and associated documentation files (the
;* "Software"), to deal in the Software without restriction, including
;* without limitation the rights to use, copy, modify, merge, publish,
;* distribute, sublicense, and/or sell copies of the Software, and to
;* permit persons to whom the Software is furnished to do so, subject to
;* the following conditions:
;*
;* The above copyright notice and this permission notice shall be
;* included in all copies or substantial portions of the Software.
;*
;* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;* EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;* MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;* IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
;* CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
;* TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
;* SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
;******************************************************************************/


; AUX LIB

LUA_ERRFILE	equ	(LUA_ERRERR+1)

luaL_Reg struct
	_name	dword	?
	func	dword	?
luaL_Reg ends


luaI_openlib			PROTO C :DWORD, :DWORD, :DWORD, :DWORD
luaL_register			PROTO C :DWORD, :DWORD, :DWORD
luaL_getmetafield	PROTO C :DWORD, :DWORD, :DWORD
luaL_callmeta			PROTO C :DWORD, :DWORD, :DWORD
luaL_typerror			PROTO C :DWORD, :DWORD, :DWORD
luaL_argerror			PROTO C :DWORD, :DWORD, :DWORD
luaL_checklstring	PROTO C :DWORD, :DWORD, :DWORD
luaL_optlstring		PROTO C :DWORD, :DWORD, :DWORD, :DWORD
luaL_checknumber	PROTO C :DWORD, :DWORD
luaL_optnumber		PROTO C :DWORD, :DWORD, :DWORD

luaL_checkinteger	PROTO C :DWORD, :DWORD
luaL_optinteger		PROTO C :DWORD, :DWORD, :DWORD

luaL_checkstack		PROTO C :DWORD, :DWORD, :DWORD
luaL_checktype		PROTO C :DWORD, :DWORD, :DWORD
luaL_checkany			PROTO C :DWORD, :DWORD

luaL_newmetatable	PROTO C :DWORD, :DWORD
luaL_checkudata		PROTO C :DWORD, :DWORD, :DWORD

luaL_where	PROTO C :DWORD, :DWORD
luaL_error	PROTO C :DWORD, :DWORD, :VARARG

luaL_checkoption	PROTO C :DWORD, :DWORD, :DWORD, :DWORD

luaL_ref		PROTO C :DWORD, :DWORD
luaL_unref	PROTO C :DWORD, :DWORD, :DWORD

luaL_loadfile		PROTO C :DWORD, :DWORD
luaL_loadbuffer	PROTO C :DWORD, :DWORD, :DWORD, :DWORD
luaL_loadstring	PROTO C :DWORD, :DWORD

luaL_newstate	PROTO C

luaL_gsub				PROTO C :DWORD, :DWORD, :DWORD, :DWORD
luaL_findtable	PROTO C :DWORD, :DWORD, :DWORD, :DWORD


;/*
;** ===============================================================
;** some useful macros
;** ===============================================================
;*/
;
;#define luaL_argcheck(L, cond,numarg,extramsg)	\
;		((void)((cond) || luaL_argerror(L, (numarg), (extramsg))))
;#define luaL_checkstring(L,n)	(luaL_checklstring(L, (n), NULL))
;#define luaL_optstring(L,n,d)	(luaL_optlstring(L, (n), (d), NULL))
;#define luaL_checkint(L,n)	((int)luaL_checkinteger(L, (n)))
;#define luaL_optint(L,n,d)	((int)luaL_optinteger(L, (n), (d)))
;#define luaL_checklong(L,n)	((long)luaL_checkinteger(L, (n)))
;#define luaL_optlong(L,n,d)	((long)luaL_optinteger(L, (n), (d)))
;
;#define luaL_typename(L,i)	lua_typename(L, lua_type(L,(i)))
;
;#define luaL_dofile(L, fn)	(luaL_loadfile(L, fn) || lua_pcall(L, 0, 0, 0))
;
;#define luaL_dostring(L, s)	(luaL_loadstring(L, s) || lua_pcall(L, 0, 0, 0))
;
;#define luaL_getmetatable(L,n)	(lua_getfield(L, LUA_REGISTRYINDEX, (n)))
;
;#define luaL_opt(L,f,n,d)	(lua_isnoneornil(L,(n)) ? (d) : f(L,(n)))
;
